<script setup>
import TokenSelector from "@/components/TokenSelector";
import { getTokenAccount, getTokenBalance } from "@/api/token";
import { createVault } from "@/api/khronos";
import { useKhronosStore } from "@/store";
import { ref, watch } from "vue-demi";
import { storeToRefs } from "pinia";

const store = useKhronosStore();

const { isConnected } = storeToRefs(store);
const depositMint = store.usdcToken;
const destinationMint = ref("");
const depositAmount = ref(10 * 1e6);
const usdcBalance = ref(0);
const usdcTokenAccount = ref("");
const period = ref(1);
const percentil = ref(10);

const onDestinationMintSelected = (mint) => {
  destinationMint.value = mint;
};

const getUserUsdcBalance = async () => {
  let tokenAccount = await getTokenAccount(store.workspace, store.usdcToken);
  usdcTokenAccount.value = tokenAccount;
  let balance = await getTokenBalance(store.workspace, usdcTokenAccount.value);
  usdcBalance.value = balance.value.amount;
};

const createNewVault = async () => {
  //period, percentil, amount, depositMint, destinationMint, initializerDepositAcc
  let tx = await createVault(
    store.workspace,
    period.value,
    percentil.value,
    depositAmount.value,
    depositMint,
    destinationMint.value,
    usdcTokenAccount.value
  );
  console.log(tx);
  await getUserUsdcBalance();
};

watch(isConnected, (cur, prev) => {
  if (cur && prev != undefined) {
    getUserUsdcBalance();
  }
});
</script>

<template>
  <div class="container mt-3">
    <h3>Create Vault</h3>
    <div class="mt-3 mb-3">
      <token-selector @tokenMintSelected="onDestinationMintSelected" />
    </div>
    <div class="col">
      <input
        type="range"
        :step="1 * 1e6"
        :min="10 * 1e6"
        :max="usdcBalance"
        v-model="depositAmount"
      />
      ${{ depositAmount / 1e6 }}
    </div>
  </div>
  <div class="row">
    <div class="col form-group">
      <label for="period">Period</label>
      <input id="period" class="form-control" type="number" v-model="period" />
    </div>
    <div class="col form-group">
      <label for="percentil">Percentil</label>
      <input id="percentil" type="number" class="form-control" v-model="percentil" />
    </div>
    
  </div>
  <div class="form-group">
    <button class="btn btn-dark mt-3" @click="createNewVault">Create vault</button>
  </div>
</template>

<style scoped>
</style>